/*
client.c
Copyright (C) 2006 - Carmine Savino & Paolo Gatti

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <arpa/inet.h>

#define STDIN 0
#define BUFFER_SIZE 1024
#define PORT 6666 //Definisce la porta in trasmissione

int main(int argc, char **argv)
{
	int s, connection, c,i,k;
	struct sockaddr_in myaddr;
	struct hostent *h;

	int boolean = 0;
	char nick[BUFFER_SIZE];
	char sux[BUFFER_SIZE];
	char buf[BUFFER_SIZE];
	char buffer[BUFFER_SIZE];
	fd_set rfds;

	if (argc != 3) {
		printf("client <host> <nick>\n");
		exit(-1);
	}


	i = 0;
	while (argv[2][i] != '\0'){	 //Scorre argv[2] per assegnare il nick
		nick[i]  = argv[2][i];
		i++;
	}
	nick[i] = '\0';


	if (!(h = gethostbyname(argv[1]))) {
		herror("gethostbyname()");
		exit(-1);
	}

	if ((s = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket()");
		exit(-1);
	}

	myaddr.sin_family = AF_INET;
	myaddr.sin_addr.s_addr =
		((struct in_addr *) h->h_addr_list[0])->s_addr;
	myaddr.sin_port = htons(PORT);
	memset(&(myaddr.sin_zero), 0, sizeof(myaddr.sin_zero));
	
	if ((connection =
		 connect(s, (struct sockaddr *) &myaddr, sizeof(myaddr))) != 0) {
		perror("connect()");
		close(s);
		exit(-1);
	}


	while (1) { //Ciclo all'infinito
		FD_ZERO(&rfds);
		FD_SET(STDIN, &rfds);
		FD_SET(s, &rfds);

		if (select(s + 1, &rfds, NULL, NULL, NULL) == -1) {
			perror("select()");
			exit(-1);
		}

		if (FD_ISSET(s, &rfds)) {


			c = recv(s, buf, sizeof(buf) - 1, 0);
			fflush(stdin);
			buf[c] = '\0';

			if (c <= 0) {
				if (c < 0)
					perror("recv()");
				close(s);
				exit(-1);
			} else
				printf("%s",buf);
		}

		if (boolean == 0){
		
			if (send(s, nick, i + 1, 0) < 0) //Il client si indetifica nel server inviando il proprio nick
				perror("send()");			
				boolean = 1;
		}else{
		
			if (FD_ISSET(STDIN, &rfds)) { //Inviamo il messaggio che l'utente ha digitato al server nel formato " Nick: messaggio "
				c = read(STDIN, buf, sizeof(buf));
				buf[c] = '\0';

				if (c > 0) { // "c" rappresenta il numero di byte correttamente letti da standard input. Se  > invio il messaggio al server.
			
					if (send(s, buf,i + c, 0) < 0)
						perror("send()");
				} else {
					if (c < 0)
					perror("read()");
					close(s);
					exit(-1);
				}
			}
		}
	}

	return 0;
}

