/*
server.c
Copyright (C) 2006 - Carmine Savino & Paolo Gatti

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <arpa/inet.h>

#define PORT 6666 //Definisce la porta in ascolto
#define BUFFER_SIZE 1024 //Definisce la grandezza del buffer


struct client{
	char nick[25];
	int fdn;
};


int main(){	
	char nick[25];
	fd_set fds, rfds;
	int s, fd, fdc, fdm,c,lunghezza;
	struct sockaddr_in myaddr, remoteaddr;
	char buf[BUFFER_SIZE];
	int j,k,i = 0;
	int newutente[100];
	int count = 0;
	struct client utente[100];
	int boolean = 0;	
	
	if ((s = socket(PF_INET, SOCK_STREAM, 0)) == -1) {	// metto in ascolto le connessioni tcp
		perror("socket()");
		exit(-1);
	}

	myaddr.sin_family = AF_INET;
	myaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	myaddr.sin_port = htons(PORT);
	memset(&(myaddr.sin_zero), 0, sizeof(myaddr.sin_zero));

	if (bind(s, (struct sockaddr *) &myaddr, sizeof(myaddr)) == -1) {	// associo socket, indirizzi e porta per determinare richieste di connessione
		perror("bind()");
		exit(-1);
	}

	if (listen(s, 100) == -1) {	// numero massimo di connessioni in fase di login
		perror("listen()");
		exit(-1);
	}

	FD_ZERO(&fds);	// per i descrittori che vogliamo monitorare
	FD_SET(s, &fds);
	fdm = s;

	while (1) {
	rfds = fds;	// insieme di descrittori per i quali voglio verificare la presenza di dati in input

	if (select(fdm + 1, &rfds, NULL, NULL, NULL) == -1) {
		perror("select()");
		exit(-1);
	}

	for (fd = 0; fd <= fdm; ++fd) {	// indivuduo su quali file descriptor si e' verificato un evento
		if(FD_ISSET(fd, &rfds)) {
			if(fd == s) {	// se il file descriptor e' relativo al socket liste significa che c'e' in coda una connessione da accettare
				socklen_t addrlen = sizeof(remoteaddr);

				if((fdc = accept(s, (struct sockaddr *) &remoteaddr, &addrlen)) != -1) {	// accetto la connessione in coda
						if(fdc > fdm)
							fdm = fdc;
				printf("connessione da %s, FD %d\n",
				inet_ntoa(remoteaddr.sin_addr), fdc); //Stampo quando un client si connette scrivendo ip e fd
				newutente[i] = fdc;
				//printf("utente %d\n",newutente[i]);
				i++;
				FD_SET(fdc, &fds);
				
				if (count == 0){
					if (send(fdc, "Benvenuto in chat!\nAttualmente sei l'unico utente connesso.\n", 61, 0) < 0) //Mandiamo un messaggio di benvenuto
						perror("send()");
					}
					else{
						if (send(fdc, "Benvenuto in chat!\nSono attualmente connessi:\n", 47, 0) < 0) //Mandiamo un messaggio di benvenuto
							perror("send()");
					
					}
				}
			}else{
				boolean = 0;
				c = recv(fd, buf, sizeof(buf), 0);	// un client manda dati
				fflush(stdin);
					k = 0;
//se l'fd del client  presente nella struttura newutente vul dire che  un nuovo client della chat
					while (k < i){
						if (fd == newutente[k]){
// inserisco quindi il nick nella struttura utente
							strcpy(utente[count].nick, buf);
							utente[count].fdn = fd;
							boolean = 1;
							count++;
							while (k < i){
								newutente[k] = newutente[k + 1];
								k++;
							}							
							k--;
						}
					k++;
					}
// inserisco il nick dell'utente nella variabile nick per usarla in modo opportuno in seguito
					for (j = 0; j < count; j++){
						if(utente[j].fdn == fd){
							strcpy(nick,utente[j].nick);
						}
					}
					
					if((c > 0) && (*buf != EOF)) {	// invio dati al/ai client
// se boolean = 1 nick  un nuovo utente
					if (boolean == 1){
						boolean == 0;
						for (j = 0; j < count - 1; j++){
// invio a tutti gli altri client connessi il messaggio "nick  entrato in chat"
							char msglista[25];
							char msgnewutente[46];
							lunghezza = strlen(nick);
							strcpy(msgnewutente, " e' entrato in chat.\n");
							if (send(utente[j].fdn, nick, lunghezza, 0) < 0)
								perror("send()");
							
							if (send(utente[j].fdn, msgnewutente, 21, 0) < 0)
								perror("send()");
						
							lunghezza = strlen(utente[j].nick);
							strcpy(msglista, utente[j].nick);
							msglista[lunghezza]= '\n';
							if (send(fd, msglista, lunghezza + 1, 0) < 0)
								perror("send()");
						}
					}else{
					//conversazione privata
// se il client invia un messaggio del tipo "/msg nick messaggio" lo intercettiamo e lo inviamo al nick di destinazione
						char *p;
						p = strstr(buf, "/msg");
						if (p != NULL){
							char cercanick[25];
							j = 5;
							while (buf[j] != ' ') {
								cercanick[j - 5] = buf[j];
								j++;
							}
							//printf("buf %s",buf);
							cercanick[j - 5] = '\0';
							j = 0;
							int entrato = 0;
							while (j < count){
								if (strcmp(utente[j].nick, cercanick) == 0) {
									entrato = 1;
// cercare il nick privato e inserire il rispettivo fd esatto qui giu
									char msgprivato[BUFFER_SIZE];
									char msgprivatotmp[BUFFER_SIZE];
									lunghezza = strlen(cercanick);
									lunghezza = lunghezza + 6;
									strcpy(msgprivatotmp,buf);//era tmp
									int z=0;
									while (msgprivatotmp[lunghezza] != '\0'){
										msgprivato[z]=msgprivatotmp[lunghezza];
										z++;
										lunghezza++;
										//printf("%s",msgprivato);
									}
									//printf("FD %d",utente[j].fdn);
									if (send(utente[j].fdn, "pvt --> ", 8, 0) < 0)
										perror("send()");
									lunghezza = strlen(nick);
									if (send(utente[j].fdn, nick, lunghezza, 0) < 0)
										perror("send()");
									if (send(utente[j].fdn, ": ", 2, 0) < 0)
										perror("send()");
									if (send(utente[j].fdn, msgprivato, z, 0) < 0)
									perror("send()");
								}
								
								j++;
							} 
// se il nick di destinazione non  connesso torna un messaggio di errore
							if (entrato == 0) {
								if (send(fd, "Errore: l'utente non e' connesso!\n", 34, 0) < 0)
									perror("send()");
							}
					
						}else{
						//conversazione publica
							for (fdc = 0; fdc <= fdm; ++fdc){
								if (FD_ISSET(fdc, &fds) && (fdc != fd) && (fdc != s)){	
									lunghezza = strlen(nick);
									if (send(fdc, nick, lunghezza, 0) < 0)
										perror("send()");
									if (send(fdc, ": ", 2, 0) < 0)
										perror("send()");
							
									if (send(fdc, buf, c, 0) < 0)
										perror("send()");
								}
							}					
						}
					}
				}else{
					if (c < 0)	// se riceve EOF chiude la connessione con il client
					perror("recv()");
					printf("scollegamento di %d\n", fd);
// invia a tutti i client connessi la scritta "nick  uscito dalla chat"
					for (j = 0; j < count + 1; j++){
						if (FD_ISSET(utente[j].fdn, &fds) && (utente[j].fdn != fd) ){
							lunghezza = strlen(nick);
							if (send(utente[j].fdn, nick, lunghezza, 0) < 0)
										perror("send()");
							if (send(utente[j].fdn, " e' uscito dalla chat.\n", 23, 0) < 0)
								perror("send()");
						}else{
// elimina il nick uscito dalla chat dalla struttura
							lunghezza = strlen(nick);
							strcpy(utente[j].nick,utente[count - 1].nick);
							utente[j].fdn = utente[count - 1].fdn;
							count--;
						}
					}
					close(fd);
					FD_CLR(fd, &fds);
				}
			}
		}
	
	}
	
	}
	return 0;
}
